unit uOverSeerExpFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, Spin, StdCtrls, ExtCtrls, Registry;

type
  TfrmConfig = class(TForm)
    lblMessage: TLabel;
    lblVariable: TLabel;
    lblProperty: TLabel;
    lblLineNr: TLabel;
    GrpMsgType: TGroupBox;
    Bevel2: TBevel;
    Bevel1: TBevel;
    Image1: TImage;
    Image12: TImage;
    Image2: TImage;
    Image9: TImage;
    Image11: TImage;
    Image5: TImage;
    Image10: TImage;
    Image8: TImage;
    Image7: TImage;
    Image6: TImage;
    Image4: TImage;
    Image3: TImage;
    Image13: TImage;
    Image15: TImage;
    Image14: TImage;
    selExitMethod: TRadioButton;
    selEnterMethod: TRadioButton;
    selProperty: TRadioButton;
    selObject: TRadioButton;
    selNote: TRadioButton;
    selWarning: TRadioButton;
    selInfo: TRadioButton;
    selSeperator: TRadioButton;
    selCheckPoint: TRadioButton;
    selError: TRadioButton;
    selComponent: TRadioButton;
    selStringList: TRadioButton;
    selBlackBoard: TRadioButton;
    selEndDebugger: TRadioButton;
    selStartDebugger: TRadioButton;
    grpData: TGroupBox;
    selInteger: TRadioButton;
    selRect: TRadioButton;
    selColor: TRadioButton;
    selAssigned: TRadioButton;
    selBoolean: TRadioButton;
    selTextOnly: TRadioButton;
    selFormatted: TRadioButton;
    selPoint: TRadioButton;
    selString: TRadioButton;
    GrpOptions: TGroupBox;
    lblDebugBlock: TLabel;
    cboxHistory: TComboBox;
    edtMessage: TEdit;
    edtVariable: TEdit;
    btnOK: TButton;
    btnCancel: TButton;
    edtProperty: TEdit;
    edtLineNr: TSpinEdit;
    StatusBar1: TStatusBar;
    PopupMenu1: TPopupMenu;
    Clearallitems1: TMenuItem;
    Deleteitembyindex1: TMenuItem;
    Savetoregistrynow1: TMenuItem;
    cboxUseifdef: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure selInfoClick(Sender: TObject);
    procedure Clearallitems1Click(Sender: TObject);
    procedure Deleteitembyindex1Click(Sender: TObject);
    procedure Savetoregistrynow1Click(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure cboxUseifdefClick(Sender: TObject);
  private
    { Private declarations }
  public
    DebugString: string;
    CompilerCond: string;
    UseCompilerCond: boolean;
    procedure LoadSettings;
    procedure SaveSettings;
  end;

var
  frmConfig    : TfrmConfig;

const
  ComboBoxHistoryLength = 6;

implementation

{$R *.DFM}

{ TfrmConfig }

procedure TfrmConfig.SaveSettings;
  function min(val1, val2: integer): integer;
  begin
    if val1 >= val2 then
      Result := val2
    else
      Result := val1;
  end;

var
  R            : TRegistry;
  I            : Integer;

begin
  R := TRegistry.Create;
  try
    R.RootKey := HKEY_CURRENT_USER;
    R.OpenKey('\Software\Delphree\Nexus\MessageExpert\CompilerDirectives', true);
    R.WriteInteger('Count', cboxHistory.Items.Count);
    for i := 0 to min(cboxHistory.Items.Count, ComboBoxHistoryLength) - 1 do
    begin
      R.WriteString('H' + IntToStr(I), cboxHistory.Items.Strings[i]);
    end;
    R.WriteBool('Enabled', UseCompilerCond);
  finally
    R.Free;
  end;
end;

procedure TfrmConfig.LoadSettings;
var
  R            : TRegistry;
  I            : Integer;
  S            : string;
  Count        : Integer;

begin
  R := TRegistry.Create;
  try
    R.RootKey := HKEY_CURRENT_USER;
    R.OpenKey('\Software\Delphree\Nexus\MessageExpert\CompilerDirectives', false);
    Count := 0;
    if R.ValueExists('Count') then Count := R.ReadInteger('Count');

    for i := 0 to Count - 1 do
    begin
      if R.ValueExists('H' + IntToStr(i)) then
      begin
        s := R.ReadString('H' + IntToStr(i));
        if s <> '' then
          cboxHistory.Items.Add(s);
      end
      else
        Break;
    end;
    if R.ValueExists('Enabled') then cboxUseifdef.Checked := R.ReadBool('Enabled');
    cboxUseifdef.OnClick(self);
  finally
    R.Free;
  end;
end;

procedure TfrmConfig.FormCreate(Sender: TObject);
begin
  Image1.Picture.Bitmap.TransparentColor := clFuchsia;
  Image2.Picture.Bitmap.TransparentColor := clFuchsia;
  Image3.Picture.Bitmap.TransparentColor := clFuchsia;
  Image4.Picture.Bitmap.TransparentColor := clFuchsia;
  Image5.Picture.Bitmap.TransparentColor := clFuchsia;
  Image6.Picture.Bitmap.TransparentColor := clFuchsia;
  Image7.Picture.Bitmap.TransparentColor := clFuchsia;
  Image8.Picture.Bitmap.TransparentColor := clFuchsia;
  Image9.Picture.Bitmap.TransparentColor := clFuchsia;
  Image10.Picture.Bitmap.TransparentColor := clFuchsia;
  Image11.Picture.Bitmap.TransparentColor := clFuchsia;
  Image12.Picture.Bitmap.TransparentColor := clFuchsia;
  Image13.Picture.Bitmap.TransparentColor := clFuchsia;
  Image14.Picture.Bitmap.TransparentColor := clFuchsia;
  Image15.Picture.Bitmap.TransparentColor := clFuchsia;
  LoadSettings;
  if cboxHistory.Items.Count > 0 then
    cboxHistory.Text := cboxHistory.Items.Strings[0]
  else
    cboxHistory.Text := 'DEBUG';
  selInfo.OnClick(self);
end;

procedure TfrmConfig.selInfoClick(Sender: TObject);

  function GetMsgTypeString: string;
  begin
    if selInfo.Checked then
      Result := 'Info'
    else
      if selNote.Checked then
        Result := 'Note'
      else
        if selWarning.Checked then
          Result := 'Warning'
        else
          Result := 'Error';
  end;

begin
  SelTextOnly.Enabled := selInfo.Checked or selWarning.Checked or selNote.Checked or selError.Checked;
  SelFormatted.Enabled := SelTextOnly.Enabled;
  SelBoolean.Enabled := SelTextOnly.Enabled;
  SelInteger.Enabled := SelTextOnly.Enabled;
  SelPoint.Enabled := SelTextOnly.Enabled;
  selRect.Enabled := SelTextOnly.Enabled;
  SelString.Enabled := SelTextOnly.Enabled;
  selAssigned.Enabled := SelTextOnly.Enabled;
  SelColor.Enabled := SelTextOnly.Enabled;

  lblVariable.Enabled := (selObject.Checked or selProperty.Checked or selComponent.Checked
    or selStringList.Checked or ((selFormatted.Checked or selBoolean.Checked or selInteger.Checked or selPoint.Checked or
    selRect.Checked or selString.Checked or selAssigned.Checked or selColor.Checked) and
    (selInfo.Checked or selNote.Checked or selWarning.Checked
    or selError.Checked)));
  edtVariable.Enabled := lblVariable.Enabled;

  lblMessage.Enabled := not (selSeperator.Checked or selStartDebugger.Checked or selEndDebugger.Checked);
  edtMessage.Enabled := lblMessage.Enabled;

  lblProperty.Enabled := selProperty.Checked;
  edtProperty.Enabled := selProperty.Checked;

  lblLineNr.Enabled := selBlackBoard.Checked;
  edtLineNr.Enabled := selBlackBoard.Checked;

  if edtVariable.Enabled then
    edtVariable.Color := clWindow
  else
    edtVariable.Color := clInactiveCaption;

  if edtMessage.Enabled then
    edtMessage.Color := clWindow
  else
    edtMessage.Color := clInactiveCaption;

  if edtProperty.Enabled then
    edtProperty.Color := clWindow
  else
    edtProperty.Color := clInactiveCaption;

  if edtLineNr.Enabled then
    edtLineNr.Color := clWindow
  else
    edtLineNr.Color := clInactiveCaption;

  if selEnterMethod.Checked or selExitMethod.Checked then
    lblMessage.Caption := 'Method Name'
  else
    if selCheckPoint.Checked then
      lblMessage.Caption := 'CP Name'
    else
      lblMessage.Caption := 'Message';

  if selFormatted.Checked then
    lblVariable.Caption := 'Arguments'
  else
    if selObject.Checked then
      lblVariable.Caption := 'Object'
    else
      if selFormatted.Checked then
        lblVariable.Caption := 'Arguments'
      else
        if selComponent.Checked then
          lblVariable.Caption := 'Component'
        else
          if selStringList.Checked then
            lblVariable.Caption := 'Stringlist'
          else
            lblVariable.Caption := 'Variable';


  if selInfo.Checked or selNote.Checked or selWarning.Checked or selError.Checked then
  begin
    if selTextOnly.Checked then
    begin
      DebugString := 'Debugger.Log' + GetMsgTypeString + '(''' + edtMessage.Text + ''');';
    end
    else
      if selFormatted.Checked then
      begin
        DebugString := 'Debugger.LogFmt' + GetMsgTypeString + '(''' + edtMessage.Text + ''', [' + edtVariable.Text + ']);';
      end
      else
        if selBoolean.Checked then
        begin
          DebugString := 'Debugger.LogBooleanEx(dbg' + GetMsgTypeString + ', ''' + edtMessage.Text + ''', ' + edtVariable.Text + ');';
        end
        else
          if selInteger.Checked then
          begin
            DebugString := 'Debugger.LogIntegerEx(dbg' + GetMsgTypeString + ', ''' + edtMessage.Text + ''', ' + edtVariable.Text + ');';
          end
          else
            if selPoint.Checked then
            begin
              DebugString := 'Debugger.LogPointEx(dbg' + GetMsgTypeString + ', ''' + edtMessage.Text + ''', ' + edtVariable.Text + ');';
            end
            else
              if selRect.Checked then
              begin
                DebugString := 'Debugger.LogRectEx(dbg' + GetMsgTypeString + ', ''' + edtMessage.Text + ''', ' + edtVariable.Text + ');';
              end
              else
                if selString.Checked then
                begin
                  DebugString := 'Debugger.LogStringEx(dbg' + GetMsgTypeString + ', ''' + edtMessage.Text + ''', ' + edtVariable.Text + ');';
                end
                else
                  if selAssigned.Checked then
                  begin
                    DebugString := 'Debugger.LogAssignedEx(dbg' + GetMsgTypeString + ', ''' + edtMessage.Text + ''', ' + edtVariable.Text + ');';
                  end
                  else
                    if selColor.Checked then
                    begin
                      DebugString := 'Debugger.LogColorEx(dbg' + GetMsgTypeString + ', ''' + edtMessage.Text + ''', ' + edtVariable.Text + ');';
                    end;
  end
  else
    if selStartDebugger.Checked then
    begin
      DebugString := 'NxStartDebug;';
    end
    else
      if selEndDebugger.Checked then
      begin
        DebugString := 'NxEndDebug;';
      end
      else
        if selCheckPoint.Checked then
        begin
          DebugString := 'Debugger.AddCheckPoint(''' + edtMessage.Text + ''');';
        end
        else
          if selSeperator.Checked then
          begin
            DebugString := 'Debugger.AddSeparator;';
          end
          else
            if selEnterMethod.Checked then
            begin
              DebugString := 'Debugger.EnterProc(''' + edtMessage.Text + ''');';
            end
            else
              if selExitMethod.Checked then
              begin
                DebugString := 'Debugger.LeaveProc(''' + edtMessage.Text + ''');';
              end
              else
                if selObject.Checked then
                begin
                  DebugString := 'Debugger.LogObject(''' + EdtMessage.Text + ''', ' + EdtVariable.Text + ');';
                end
                else
                  if selProperty.Checked then
                  begin
                    DebugString := 'Debugger.LogProperty(''' + EdtMessage.Text + ''', ' + EdtVariable.Text + ', ' + edtProperty.Text + ');';
                  end
                  else
                    if selComponent.Checked then
                    begin
                      DebugString := 'Debugger.LogComponent(''' + EdtMessage.Text + ''', ' + EdtVariable.Text + ');';
                    end
                    else
                      if selStringList.Checked then
                      begin
                        DebugString := 'Debugger.LogStringList(''' + EdtMessage.Text + ''', ' + EdtVariable.Text + ');';
                      end
                      else
                        if selBlackBoard.Checked then
                        begin
                          DebugString := 'Debugger.ScratchPad(' + IntToStr(edtLineNr.Value) + ', ''' + edtMessage.Text + ''');';
                        end;


  StatusBar1.SimpleText := DebugString;
  CompilerCond := '{$IFDEF ' + cboxHistory.Text + '}';

  btnOK.Enabled := (DebugString <> '');
end;

procedure TfrmConfig.btnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmConfig.btnOKClick(Sender: TObject);
begin
  if ((cboxHistory.Items.IndexOf(cboxHistory.Text) = -1) and (cboxHistory.Text <> '')) then
    cboxHistory.Items.Insert(0, cboxHistory.Text);
  SaveSettings;
end;

procedure TfrmConfig.Clearallitems1Click(Sender: TObject);
begin
  if MessageDlg('Are you sure that you want to clear the History now ?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    cboxHistory.Items.Clear;
end;

procedure TfrmConfig.Deleteitembyindex1Click(Sender: TObject);
var
  s            : string;
  i            : integer;
begin
  if InputQuery('Select Item (0..' + IntToStr(cboxHistory.Items.Count - 1) + ')', 'Index : ', s) then
  begin

    try
      i := StrToInt(s);
      if i > cboxHistory.Items.Count - 1 then
        MessageDlg('Invalid Item Index !', mtError, [mbOK], 0)
      else
        if MessageDlg('Delete Item #' + S + ' ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
          cboxHistory.Items.Delete(i);
    except on E: Exception do
      begin
        MessageDlg('Invalid Input !' + #13 + #10 + E.Message, mtError, [mbOK], 0);
        exit;
      end;
    end

  end;
end;

procedure TfrmConfig.Savetoregistrynow1Click(Sender: TObject);
begin
  SaveSettings;
end;

procedure TfrmConfig.cboxUseifdefClick(Sender: TObject);
begin
  if not cboxUseifdef.Checked then
  begin
    UseCompilerCond := false;
    lblDebugBlock.Enabled := false;
    cboxHistory.Enabled := false;
    cboxHistory.Color := clGray;
  end
  else
  begin
    UseCompilerCond := true;
    lblDebugBlock.Enabled := true;
    cboxHistory.Enabled := true;
    cboxHistory.Color := clWindow;
  end;
end;

end.

